Kira 2.1
=============

New features
------------

 * Added `kira2formfill` to export `fill` statements to `results/<TOPOLOGY>/kira_<SELECTED>.h`, which can be used to fill `TableBase` objects in FORM.


Changes
-------

 * Introduced a version number for the database. Databases produced prior to Kira 2.1 cannot be used for `kira2form` and `kira2formfill` unless they are upgraded with the command line argument `--force_database_format=fermat|firefly`. Read this [wiki article](https://gitlab.com/kira-pyred/kira/-/wikis/Upgrading-the-database-format) for details.

 * The numerators of the rational functions exported with `kira2form` and `kira2formfill` are now enclosed by `num()`.

 * The prefactors submitted through `insert_prefactors` are now enclosed by `prefactor[]` when employing `kira2math` and by `prefactor()` when using `kira2form` and `kira2formfill`.

 * `Meson` build system: Removed the default option `libdir=lib`. On Debian-based systems (e.g. Ubuntu) this should be set manually by the user as explained in `README.rst`.


Bug fixes
---------

 * In a reduction with Fermat, integers and rational numbers were truncated after 2048 characters leading to wrong results or a segmentation fault if the 2048th character was the `/` character. This was fixed. See [issue 14](https://gitlab.com/kira-pyred/kira/-/issues/14).

 * Fixed that using different loop momenta in different topologies led to wrong symmetries. See [issue 7](https://gitlab.com/kira-pyred/kira/-/issues/7).

 * Fixed that loop momenta defined by appending a `2` to another momentum, e.g. `k` and `k2`, led to wrong trivial sectors and symmetries. See [issue 8](https://gitlab.com/kira-pyred/kira/-/issues/8).

 * Fixed that in very rare cases wrong symmetries were found when defining propagators in the Euclidean metric. See [issue 10](https://gitlab.com/kira-pyred/kira/-/issues/10).

 * Fixed that exporting results produced with `run_firefly` employing `kira2form` could produce wrong `id` statements. See [issue 11](https://gitlab.com/kira-pyred/kira/-/issues/11).

 * Fixed that some files generated by `run_triangular` were not properly read in by `run_firefly: back` which then only solved a subsystem and produced an incomplete result. See [issue 9](https://gitlab.com/kira-pyred/kira/-/issues/9).

 * Fixed that `kira2file` added extra lines consisting of `0` after vanishing integrals so that the resulting files could not be read in by `input_system`. See [issue 15](https://gitlab.com/kira-pyred/kira/-/issues/15).

 * Fixed that pure export jobs could crash with `pyred::init_error`. See [issue 16](https://gitlab.com/kira-pyred/kira/-/issues/16).

 * Fixed that Kira generates and reduces the **whole** system of equations for **all** integrals within the seed boundaries if all selected integrals belong to trivial sectors or are master integrals. See [issue 12](https://gitlab.com/kira-pyred/kira/-/issues/12).

 * `results/<TOPOLOGY>/masters` is now written in its entirety before generating the `tmp/<TOPOLOGY>/SYS` files.
